#include "extrctstr.h"

namespace extrctsubstr {

	using namespace std;
	
		char * s_to_c(string s, char * c) {
			if (s.length() > 0)
				for (int i = 0; i < s.length(); i++)
					c[i] = s[i];
			c[s.length()] = 0;
			return c;
		}

		bool ExtrctStr::checkChar(char c) {
			bool v = false;
			for (int i = 0; i < seps.length(); i++)
				if (c == seps[i]) v = true;
			return v;
		}

		void ExtrctStr::CheckStr(string str) {
			if (str.length() <= 0) {
				n_match = -1;
				wd_list.clear();
				nR = -1;
				wd_listR.clear();
				return;
			}

			n_match = 0;
			for (int i = 0; i < str.length(); i++)
				if (checkChar(str[i])) n_match++;
			
			wd_list.clear();
			if (n_match < 1) {
				wd_list.insert(wd_list.end(), str);
			}
			else {
				int s_pos = -1, e_pos = 0;
				for (int k = 0; k < n_match; k++) {
					while (!checkChar(str[e_pos])) e_pos++;
					if (s_pos + 1 < e_pos) {
						wd_list.insert(wd_list.end(), str.substr(s_pos + 1, e_pos - s_pos - 1));
					}
					else {
						wd_list.insert(wd_list.end(), "");
					}
					s_pos = e_pos++;
				}
				if (s_pos >= (str.length() - 1)) {
					wd_list.insert(wd_list.end(), "");
				}
				else {
					wd_list.insert(wd_list.end(), str.substr(s_pos + 1));
				}
			}

			nR = 0;
			wd_listR.clear();
			for (int i = 0; i < n_match + 1; i++) {
				if (wd_list[i] != "") {
					wd_listR.insert(wd_listR.end(), wd_list[i]);
					nR++;
				}
			}
		
		}

		string ExtrctStr::getStr(int p) {
			if (n_match < 0)
				return "";

			string str;
			if (wd_list.empty()) {
				str = "";
			}
			else {
				if (p > n_match) {
					str = "";
				}
				else {
					str = wd_list[p];
				}
			}
			return str;
		}

		string ExtrctStr::getStrR(int p) {
			if (n_match < 0)
				return "";

			string str;
			if (nR < 1) {
				str = "";
			}
			else if (p < nR) {
				str = wd_listR[p];
			}
			else {
				str = "";
			}
			return str;
		}
		
}